unit gx2lib;
interface

uses grafx2,gx_glob,newfrontier,stream32,objects;

  function   loadgx2(var stream : tstream32;var image : timage) : word;
  function   savegx2(var stream : tstream32;image : timage) : word;

implementation

function loadgx2(var stream : tstream32;var image : timage) : word;
var
  err   : word;
  count : longint;
begin
  loadgx2 := errfileerror;
  if (stream.status <> stok) then exit;
  err := errnoerror;
  if (image.id = idimage)and(image.data <> 0) then err := closeimage(image);
  loadgx2 := err;
  if err <> errnoerror then exit;
  stream.read32(farptr(@image),sizeof(timage));
  image.data := 0;
  if (image.id <> idimage)or(image.version <> $0100) then begin
    loadgx2 := errfalseformat;
    stream.done;
    exit;
  end;
  getmem32(image.data,image.size);
  count := stream.read32(ptr48(image.data,0),image.size);
  if (count <> image.size) then exit;
  stream.done;
  loadgx2 := errnoerror;
end;

function savegx2(var stream : tstream32;image : timage) : word;
begin
  savegx2 := errfileerror;
  if (stream.status <> stok) then exit;
  savegx2 := errnodiskmem;
  image.flags := image.flags and not imlocked;
  stream.write32(farptr(@image),sizeof(timage));
  if (stream.status <> stok) then begin
    stream.done;
    exit;
  end;
  stream.write32(ptr48(image.data,0),image.size);
  if (stream.status <> stok) then begin
    stream.done;
    exit;
  end;
  {$I+}
  savegx2 := errnoerror;
  stream.done;
end;

begin
end.